{% extends "crud.html" %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block add_form %}
    <div class="row">
        <div class="col-12 col-md-6">
            <div class="form-group">
                <label>{{ "name"|normalize|title }}*</label>
                <input type="text" name="name" class="form-control" value="" required maxlength="255" />
            </div>
        </div>
        <div class="col-12 col-md-6">
            <div class="form-group">
                <label>{{ "department"|normalize|title }}</label>
                <input type="text" name="department" class="form-control" value="" maxlength="255" />
            </div>
        </div>
    </div>
    <hr />
    <h5>Default Modules</h5>
    <table class="table table-striped table-hover table-bordered">
        <thead>
            <tr>
                <th>Module</th>
                <th class="text-center">View/Read</th>
                <th class="text-center">Add</th>
                <th class="text-center">Edit</th>
                <th class="text-center">Delete</th>
                <th class="text-center"><small>Select All</small></th>
            </tr>
        </thead>
        <tbody>
            {% for module in DEFAULT_MODULES %}
                <tr>
                    <td>{{ module|normalize|title }}</td>
                    <td><input name="level-read" type="checkbox" class="form-control" value="{{ module }}" /></td>
                    <td><input name="level-create" type="checkbox" class="form-control" value="{{ module }}" /></td>
                    <td><input name="level-update" type="checkbox" class="form-control" value="{{ module }}" /></td>
                    <td><input name="level-delete" type="checkbox" class="form-control" value="{{ module }}" /></td>
                    <td><input type="checkbox" class="form-control" data-select-all="row" /></td>
                </tr>
            {% endfor %}
        </tbody>
        <tfoot>
            <tr>
                <td class="text-muted">Select All</td>
                <td><input type="checkbox" class="form-control" data-select-all="column" data-column-index="1" /></td>
                <td><input type="checkbox" class="form-control" data-select-all="column" data-column-index="2" /></td>
                <td><input type="checkbox" class="form-control" data-select-all="column" data-column-index="3" /></td>
                <td><input type="checkbox" class="form-control" data-select-all="column" data-column-index="4" /></td>
                <td></td>
            </tr>
        </tfoot>
    </table>
{% endblock %}


{% block empty_spiel %}
    Add Access Control Levels -ACLs
    <br />
    These settings facilitate permission enforecement for users per module.
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'name',
        render: function(data) {
            return '<a href="#" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> {0}</a>'.format(data);
        }
    },
    {
        data: 'department',
        render: function(data) {
            return (isDefined(data)) ? data: '';
        }
    },
    {
        data: 'date_created',
        className: 'd-none d-sm-none d-md-table-cell'
    },
    {
        data: '_id',
        sortable: false,
        className: 'text-center',
        render: function(data) {
            return '<a href="#" class="btn btn-danger btn-sm btn-block" data-crud="delete" data-delete-target="{0}"><i class="fa fa-trash fa-fw"></i> Delete</a>'.format(data);
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    $dom.document.on('change', 'input[data-select-all]', function() {
        let target = $(this).attr('data-select-all');
        let val = $(this).prop('checked');
        if (target === 'row') {
            $(this).closest('tr').find('input[type="checkbox"][value]').prop('checked', val);
        } else if (target === 'column') {
            let index = parseInt($(this).attr('data-column-index'));
            $.each($(this).closest('table').find('tbody > tr'), function(i, v) {
                $(v).find('td:eq({0}) input[type="checkbox"][value]'.format(index)).prop('checked', val);
            });
        }
    });

    // TODO: Detect if row/column select all on details
{# </script> #}
{% endblock %}
